; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License Version 3.
; This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
; See the attached file or the link below.
; http://www.gnu.org/licenses/gpl-3.0.html
;
; Copyright (C) 2008 鉄(Tetsu) <web@ironsand.net>
; Webpage : http://gimp.sblo.jp/ (lang:jp)
;
; This file provide functions that I often use.
; last updae 2009/03/15 add:remove-extension, chop
(define (fe-drawable-scale-from-height drawable height)
        (let ((h (car (gimp-drawable-height (car (gimp-image-get-active-drawable drawable)))))
              (w (car (gimp-drawable-width (car (gimp-image-get-active-drawable drawable))))))
          (gimp-image-scale drawable (* (/ height h) w) height))
        drawable)
(define (fe-drawable-scale-from-width drawable width)
        (let ((h (car (gimp-drawable-height (car (gimp-image-get-active-drawable drawable)))))
              (w (car (gimp-drawable-width (car (gimp-image-get-active-drawable drawable))))))
          (gimp-image-scale img (* (/ width w)) h))
        drawable)
(define (fe-drawble-fill-with-color drawable color)
        (let ((orig-color (car (gimp-context-get-foreground))))
          (gimp-context-set-foreground color)
          (gimp-edit-fill drawable FOREGROUND-FILL)
          (gimp-context-set-foreground orig-color)))
(define concat string-append)
(define (++ n) (+ n 1))
(define (-- n) (- n 1))
(define (/2 n) (/ n 2))
(define (inverse n) (/ 1 n))
(define (m* m1 m2)
        (if (null? m2) ()
          (cons
           (apply + (map * m1 (car m2)))
           (m* m1 (cdr m2)))))
(define (fe-text-layer-new img text font font-size 0)
        (let ((layer (car (gimp-text-layer-new img text font font-size 0))))
          (gimp-image-add-layer img layer 0)
          layer))
(define (chop str)
        (substring str 0 (- (string-length str) 1)))
(define (remove-extension str)
        (if (string? (remove-extension-if-thereis str))
            (remove-extension-if-thereis str)
          str))
(define (remove-extension-if-thereis str)
        (cond ((= (string-length str) 0) #f)
              ((eqv? (string-ref str (- (string-length str) 1)) #\.)
               (chop str))
              (#t (remove-extension-if-thereis (chop str)))))